#include <stdio.h>
#include <ssdef.h>
#include <stdlib.h>

#define SENTINAL -16

extern int sys$setast(), lib$signal();

static void dummy_access(sent, flag, last)
  char sent, flag, last;
{
   printf("%s: error trying to free!!! %s sentinal has been replaced by %d!\n",
          (flag==0)?"CHECK":"REAL", last?"END":"START", sent);
   lib$signal(88);
}

void check_access(add)
  char *add;
{
  short *slen;
  if (!add) return;
  slen = (short *)((int)add - 3);
  if (add[*slen] != SENTINAL) dummy_access(add[*slen], 0, 0);
  if (add[-1] != SENTINAL) dummy_access(add[-1], 0, 1);
}

void myfree(add)
  char *add;
{
  char *sent;
  short *len;
  int old;
  if (!add) return;
  old = sys$setast(0);
  len = (short *)((int)add - 3);
  if (add[*len] != SENTINAL) dummy_access(add[*len], 1, 0);
  if (add[-1] != SENTINAL) dummy_access(add[-1], 1, 1);
  add[*len] = 0;
  add[-1] = 0;
  free(&add[-3]);
  if (old == SS$_WASSET) sys$setast(1);
}

/*

size data sentinal  real data    sentinal
[0][1]    [2]       [3][4][5]    [6]

*/

char *mymalloc(len)
  int len;
{
  char *ret;
  short *rlen;
  int old;

  if (!len) return NULL;
  old = sys$setast(0);
  ret = (char *)malloc(len+4);
  rlen = (short *)ret;
  ret += 3;
  *rlen = len;
  ret[-1] = SENTINAL;
  ret[len] = SENTINAL;
  if (old == SS$_WASSET) sys$setast(1);
  return ret;
}
